/***************************************************************************
 *   Copyright (C) 1998-2009 by David Bucciarelli (davibu@interfree.it)    *
 *                                                                         *
 *   This file is part of SmallptGPU.                                      *
 *                                                                         *
 *   SmallptGPU is free software; you can redistribute it and/or modify    *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   SmallptGPU is distributed in the hope that it will be useful,         *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

/*
 * Based on smallpt, a Path Tracer by Kevin Beason, 2008
 * Modified by David Bucciarelli to show the output via OpenGL/GLUT, ported
 * to C, work with float, fixed RR, ported to OpenCL, etc.
 */

#include "displayfunc.h"

using namespace std;

int main(int argc, char *argv[]) {
	try {
		cerr << "Usage: " << argv[0] << endl;
		cerr << "Usage: " << argv[0] << " <use CPU devices (0 or 1)> <use GPU devices (0 or 1)> <GPU workgroup size (0=default value or anything > 0 and power of 2)> <window width> <window height> <scene file>" << endl;

		// It is important to initialize OpenGL before OpenCL
		unsigned int width;
		unsigned int height;
		if (argc == 7) {
			width = atoi(argv[4]);
			height = atoi(argv[5]);
		} else if (argc == 1) {
			width = 1024;
			height = 768;
		} else
			exit(-1);

		InitGlut(argc, argv, width, height);

		if (argc == 7)
			config = new RenderConfig(argv[6], width, height,
					(atoi(argv[1]) == 1), (atoi(argv[2]) == 1), atoi(argv[3]));
		else if (argc == 1)
			config = new RenderConfig("scenes/cornell.scn", width, height, true, true, 0);
		else
			exit(-1);

		RunGlut();
	} catch (cl::Error err) {
		cerr << "ERROR: " << err.what() << "(" << err.err() << ")" << endl;
	}

	return EXIT_SUCCESS;
}
